#include "WiFi.h"
#include "WebServer.h"
#include "Update.h"

WebServer server(80);

char* ssid = "Web";
char* pass = "1234567890";
int val;
unsigned long time1,time2;

void setup() {
  Serial.begin(115200);
  Serial.println("");
  Serial.println("WebServer");
  Serial.println("update?");
  //Serial.println("update!");
  Serial.println("");
  WiFi.mode(WIFI_AP);
  WiFi.softAP(ssid, pass);

  server.on("/update", HTTP_GET, [](){
  server.send(200, "text/html", "<form method='POST' action='/update' enctype='multipart/form-data'><input type='file' name='update'><input type='submit' value='Update'></form>");
  });
  updateOTA();
  server.begin();
}

void loop() {
  server.handleClient();
}

void updateOTA() {
  server.on("/update", HTTP_POST, [](){
    server.sendHeader("Connection", "close");
    server.send(200, "text/plain", (Update.hasError())?"FAIL":"OK");
    delay(100);
    ESP.restart();
  },[](){
    HTTPUpload& upload = server.upload();
    if(upload.status == UPLOAD_FILE_START){
      time1 = millis()/1000;
      Serial.printf("Update: %s\n", upload.filename.c_str());
      uint32_t maxSketchSpace = 0x140000;
      if(!Update.begin(maxSketchSpace)){
        Update.printError(Serial);
      }
    } else if(upload.status == UPLOAD_FILE_WRITE){
      if(Update.write(upload.buf, upload.currentSize) != upload.currentSize){
        Update.printError(Serial);
      }
    } else if(upload.status == UPLOAD_FILE_END){
      if(Update.end(true)){
        time2 = millis()/1000; 
        Serial.printf("Update Success: %u B\nUpload time: %d sec.\nRebooting...\n\n", upload.totalSize, time2 - time1);
      } else {
        Update.printError(Serial);
      }
    }
    yield();
  });
}
